> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Post oauthclient

> Create a new OAuth application



## OpenAPI

````yaml /swagger.json post /oauth/client
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
paths:
  /oauth/client:
    post:
      tags:
        - oauth
      description: Create a new OAuth application
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                description:
                  type: string
                homepage:
                  type: string
                  format: uri
                logo:
                  type: string
                scopes:
                  type: array
                  items:
                    type: string
                    enum:
                      - table|create
                      - table|delete
                      - table|export
                      - table|import
                      - table|read
                      - table|update
                      - table|trash_read
                      - table|trash_update
                      - table|trash_reset
                      - view|create
                      - view|delete
                      - view|read
                      - view|update
                      - field|create
                      - field|delete
                      - field|read
                      - field|update
                      - record|comment
                      - record|create
                      - record|delete
                      - record|read
                      - record|update
                      - automation|create
                      - automation|delete
                      - automation|read
                      - automation|update
                      - user|email_read
                      - user|integrations
                redirectUris:
                  type: array
                  items:
                    type: string
                    format: uri
                  minItems: 1
              required:
                - name
                - homepage
                - redirectUris
      responses:
        '201':
          description: Returns the created OAuth application
          content:
            application/json:
              schema:
                type: object
                properties:
                  clientId:
                    type: string
                  name:
                    type: string
                  secrets:
                    type: array
                    items:
                      type: object
                      properties:
                        id:
                          type: string
                        secret:
                          type: string
                        lastUsedTime:
                          type: string
                      required:
                        - id
                        - secret
                  scopes:
                    type: array
                    items:
                      type: string
                  logo:
                    type: string
                    format: uri
                  homepage:
                    type: string
                    format: uri
                  redirectUris:
                    type: array
                    items:
                      type: string
                      format: uri
                required:
                  - clientId
                  - name
                  - homepage
                  - redirectUris
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request POST \
              --url https://app.teable.ai/api/oauth/client \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
              --header 'content-type: application/json' \
              --data '{"name":"string","description":"string","homepage":"http://example.com","logo":"string","scopes":["table|create"],"redirectUris":["http://example.com"]}'
        - lang: JavaScript
          source: |-
            const url = 'https://app.teable.ai/api/oauth/client';
            const options = {
              method: 'POST',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              },
              body: '{"name":"string","description":"string","homepage":"http://example.com","logo":"string","scopes":["table|create"],"redirectUris":["http://example.com"]}'
            };

            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: |-
            const http = require('https');

            const options = {
              method: 'POST',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/oauth/client',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              }
            };

            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });

            req.write(JSON.stringify({
              name: 'string',
              description: 'string',
              homepage: 'http://example.com',
              logo: 'string',
              scopes: ['table|create'],
              redirectUris: ['http://example.com']
            }));
            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            payload =
            "{\"name\":\"string\",\"description\":\"string\",\"homepage\":\"http://example.com\",\"logo\":\"string\",\"scopes\":[\"table|create\"],\"redirectUris\":[\"http://example.com\"]}"


            headers = {
                'Authorization': "Bearer REPLACE_BEARER_TOKEN",
                'content-type': "application/json"
            }


            conn.request("POST", "/api/oauth/client", payload, headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````